UNIT Rem_Type;

{ RemType enthlt die DOS- und Redirector-Datenstrukturen, die von bei- }
{ den Programmen bentigt werden.                                       }

INTERFACE

{ --------------------------------------------------------------------- }
{ -------------------------- DOS-Datentypen --------------------------- }
{ --------------------------------------------------------------------- }

{ SDB stellt den Search-Data-Block dar. Der Search-Data-Block wird nur  }
{ von FindFirst/Next verwendet. Er ist Teil der SDA (Swappable-Data-    }
{ Area von DOS. Der Block wird durch FindFirst initialisiert und durch  }
{ FindNext weiterverwendet.                                             }
TYPE FCBArray = ARRAY[0..10] OF CHAR;
     SDB_Ptr = ^SDB_Rec;
     SDB_Rec = RECORD
       Drv_Lett  : BYTE;                 { Nummer des Laufwerks + Bit7  }
       Srch_Tmpl : FCBArray;             { Filename mit Wildcards       }
       Srch_Attr : BYTE;                 { Suchattribut                 }
       Dir_Entry : WORD;                 { 0 = Vol, 1 = Dir, 2 = File   }
                                         { zwingend ???                 }
       Par_Clstr : WORD;                 { ???                          }
       F1        : ARRAY[1..4] OF BYTE;  { ???                          }
     END;

{ Die SFT ist das Rckgrat des DOS-File-Systems. Die Anzahl der SFT's   }
{ werden durch FILES= angegeben. Die SFT's werden hier immer gebraucht, }
{ wenn Files maniuliert werden sollen.                                  }
     SFT_Ptr = ^SFT_Rec;
     SFT_Rec = RECORD
       Handle_Cnt,                { Anzahl der Handles, die zugreifen   }
                                  { 0: SFT ist frei.                    }
       Open_Mode      : WORD;     { Open- und Sharebits 0..1            }
                                  { S. 432 Schpers                     }
       Attr_Byte      : BYTE;     { Attribut der Files (siehe TP)       }
       Dev_Info       : WORD;     { Gerte-Info 0..4: Laufwerksnr.      }
                                  { 6: nicht verndert, 15 = Netzwerk   }
                                  { vermutlich 12,13,14 Physical,Join,  }
                                  { Subst                               }
       DevDrv_Ptr     : POINTER;  { Zeiger auf Gertetreiber            }
       Start_Clstr,                       { we don't need to touch this }
       f_Time,                    { Zeit des Files                      }
       f_Date         : WORD;     { Datum ds Files                      }
       f_Size,                    { Gre des Files                     }
       f_Pos          : LongInt;  { Position im File                    }
       Rel_LastClstr,                     { we don't need to touch this }
       Abs_LastClstr,                     { we don't need to touch this }
       Dir_Sector     : WORD;             { we don't need to touch this }
       Dir_EntryNo    : BYTE;             { we don't need to touch this }
       FCB_Fn : FCBArray;             { Filename im FCB-Format          }
     END;

{ Die CDS ist die DOS Current directory structure. Pro Laufwerk gibt es }
{ ein Feld in der CDS, das angibt, welcher aktuelle Pfad existiert,     }
{ welchen Tp das Laufwerk besitzt und welcher Teil des Pfades auch      }
{ wirklich angezeigt wird.                                              }
{ ------------------------ DOS VERSION 3.xx --------------------------- }
     PathArray = ARRAY [0..66] OF CHAR;
     PathPtr   = ^PathArray;
     ASCIIZ    = ARRAY [0..127] OF CHAR;
     Cds3_Rec = RECORD
       Curr_Path : PathArray;             { aktueller Pfad fr's Lw     }
       Flags     : WORD;                  { Bit 12,13,14,15: Subst,     }
                                          { Join, Physical, Network     }
       F1        : ARRAY[1..10] OF BYTE;  { we don't need to touch this }
       Root_Ofs  : WORD;                  { Offset zum angezeigten Pfad }
     END;                                 { (Backslash-Offset)          }
{ ------------------------ DOS VERSION 4.xx --------------------------- }
     Cds4_Rec = RECORD
       Curr_Path : PathArray;             { s.o.                        }
       Flags     : WORD;                  { s.o.                        }
       F1        : ARRAY[1..10] OF BYTE;  { we don't need to touch this }
       Root_Ofs  : WORD;                  { s.o.                        }
       F2        : ARRAY[1..7] OF BYTE;   { we don't need to touch this }
     END;
     Cds_Array = RECORD
       CASE BOOLEAN OF
         TRUE  : (Cds3 : ARRAY [1..64] OF Cds3_Rec);
         FALSE : (Cds4 : ARRAY [1..64] OF Cds4_Rec);
     END;

{ Directory-Eintrag fr gefundenes File. dir_rec wird v. FindFirst/Next }
{ gesetzt, um DOS das File mitzuteilen.                                 }
     Dir_Ptr = ^Dir_Rec;
     Dir_Rec = RECORD
       FName       : FCBArray;             { Name des Files             }
       FAttr       : BYTE;                 { Attribute des Files        }
       F1          : ARRAY[1..10] OF BYTE; { reserviert                 }
       Time_LstUpd,                        { Zeit d. letzten Updates    }
       Date_LstUpd,                        { datum des letzten Updates  }
       Start_Clstr : WORD;                { we don't need to touch this }
       fSiz        : LongInt;              { Gre des Files            }
     END;

{ Die SDA ist die Swappable DOS Area. In ihr werden alle Daten gespei-  }
{ chert, die DOS nicht reentrant machen - wird sie gesichert, kann ein  }
{ Programm problemlos sich einmischen. Die SDA enthlt alle wichtigen   }
{ DOS-Variablen. Der Record stellt hiervon eine Untermenge dar.         }
{ ------------------------ DOS VERSION 3.xx --------------------------- }
     Sda3_rec = RECORD
       F0            : ARRAY[1..12] OF BYTE;
       Curr_Dta      : POINTER;               { aktuelle Adresse der DTA  }
       Curr_Psp      : WORD;                  { aktueller PSP             }
       F1            : ARRAY[1..28] OF BYTE;
       dd,                                    { Tag,Monat und Jahr        }
       mm            : BYTE;
       yy_1980       : WORD;
       F2            : ARRAY[1..96] OF BYTE;
       Fn1,                                   { Filename fr Operation    }
       Fn2           : ASCIIZ;                { 2. Filename fr Rename    }
       SDB           : SDB_Rec;               { Search-Data-Block         }
       Found_File    : Dir_Rec;               { DIR-Eintrag fr gef. File }
       Drive_CdsCopy : Cds3_Rec;
       FCB_Fn1       : ARRAY[0..10] OF CHAR;  { Name fr FindFirst        }
       F3            : BYTE;
       FCB_Fn2       : ARRAY[0..10] OF CHAR;
       F4            : ARRAY[1..11] OF BYTE;
       Srch_Attr     : BYTE;                  { Suchattr. fr FindFirst   }
       Open_Mode     : BYTE;                  { Open-Mode fr OpenFile    }
       F5            : ARRAY[1..48] OF BYTE;
       Drive_CdsPtr  : POINTER;               { Zeiger auf den CDS-Eintrag}
       F6            : ARRAY[1..12] OF BYTE;
       Fn1_CsOfs,                             { Ptr. auf fn1 ss:fn1.csofs }
       Fn2_CsOfs     : WORD;                  { Ptr. auf fn2 ss:fn2.csofs }
       F7            : ARRAY[1..56] OF BYTE;
       Ren_SrcFile   : SDB_Rec;
       Ren_File      : Dir_Rec;
     END;
{ ------------------------ DOS VERSION 4.xx --------------------------- }
     tSpecPop = RECORD
       sPop_act,                             { Special purpose open action }
       sPop_attr,                            {            "       attribut }
       sPop_mode     : WORD;                 {            "           mode }
     END;
     Sda4_Ptr = ^Sda4_Rec;
     Sda4_Rec = RECORD
       F0            : ARRAY[1..12] OF BYTE;
       Curr_Dta      : POINTER;
       Curr_Psp      : WORD;
       F1            : ARRAY[1..30] OF BYTE;
       dd,
       mm            : BYTE;
       yy_1980       : WORD;
       F2            : ARRAY[1..106] OF BYTE;
       Fn1,
       Fn2           : ASCIIZ;
       SDB           : SDB_Rec;
       Found_File    : Dir_Rec;
       Drive_CdsCopy : Cds4_Rec;
       FCB_Fn1       : ARRAY[0..10] OF CHAR;
       F3            : BYTE;
       FCB_Fn2       : ARRAY[0..10] OF CHAR;
       F4            : ARRAY[1..11] OF BYTE;
       Srch_Attr     : BYTE;
       Open_Mode     : BYTE;
       F5            : ARRAY[1..51] OF BYTE;
       Drive_CdsPtr  : POINTER;
       F6            : ARRAY[1..12] OF BYTE;
       Fn1_CsOfs,
       Fn2_CsOfs     : WORD;
       F7            : ARRAY[1..71] OF BYTE;
       sPop          : tSpecPop;          { !!!!! Schpers, S.870 !!!!! }
       F8            : ARRAY[1..29] OF BYTE;
       Ren_SrcFile   : SDB_Rec;
       Ren_File      : Dir_Rec;
     END;

{ Die LoL ist die DOS List of lists structure. Sie enthlt einen Ver-   }
{ weis auf alle relevanten Listen in DOS. Hier sind nur die interessan- }
{ ten Teile dargestellt.                                                }
     LoL_Rec = RECORD
       F1         : ARRAY[1..22] OF BYTE;
       CDS        : ^Cds_Array;          { Zeiger auf CDS               }
       F2         : ARRAY[1..7] OF BYTE;
       Last_Drive : BYTE;                { Nummer des letzten Laufwerks }
     END;

TYPE
      { fxType ist der Typ des Befehls. Er wird zur besseren Lesbarkeit }
      { verwendet.                                                      }
      fxType = (_RemDir, _MakeDir, _ChDir, _Close, _Commit, _Read,
                _Write, _GetSpace, _SetAttr, _GetAttr, _Rename, _Delete,
                _Open, _Create, _FindFirst, _FindNext, _SeekEnd, _Hook,
                _ExtendOpen, _KillContact);

      { par_command_head wird bei jedem Befehl an das Remote-Laufwerk   }
      { bertragen. Je nach Kommandocode folgen diesem Kopf noch        }
      { weitere Daten.                                                  }
      fx_Command_Head = RECORD
        Current_PSP  : WORD;
        CASE Command : fxType OF
          _RemDir, _MakeDir, _ChDir, _GetSpace, _SetAttr, _GetAttr, _Rename,
          _Delete, _Open, _Create, _FindFirst, _ExtendOpen:
            ( Fn1     : ASCIIZ;
              Param0  : WORD);              { ASCIIZ-String + Parameter }
          _Close, _Commit, _Read, _Write, _SeekEnd :
            ( SFT     : SFT_Rec;                        { SFT fr File  }
              Param1  : WORD;
              Param2  : WORD);                              { Parameter }
          _FindNext:
            ( SDB     : SDB_Rec;                { SDB fr weitere Suche }
              Dir     : Dir_Rec);
          _Hook       : ();
      END;

      Ans_RemDir     = RECORD Flags,AX : WORD; END;
      Ans_MakeDir    = RECORD Flags,AX : WORD; END;
      Ans_ChDir      = RECORD Flags,AX : WORD; Curr_Path : PathArray; END;
      Ans_Close      = RECORD Flags,AX : WORD; SFT : SFT_Rec; END;
      Ans_Commit     = RECORD END;
      Ans_Read       = RECORD Flags,AX,Size : WORD; SFT : SFT_Rec; END;
      Ans_Write      = RECORD Flags,AX,Size : WORD; SFT : SFT_Rec; END;
      Ans_GetSpace   = RECORD Spc,Totc,Bps,Freec : WORD; END;
      Ans_SetAttr    = RECORD Flags,AX : WORD; END;
      Ans_GetAttr    = RECORD Flags,AX : WORD; BX,DI : WORD; END;
      Ans_Rename     = RECORD Flags,AX : WORD; END;
      Ans_Delete     = RECORD Flags,AX : WORD; END;
      Ans_Open       = RECORD Flags,AX : WORD; SFT : SFT_Rec; END;
      Ans_Create     = RECORD Flags,AX : WORD; SFT : SFT_Rec; END;
      Ans_FindFirst  = RECORD Flags,AX : WORD; SDB : SDB_Rec; DIB : Dir_Rec; END;
      Ans_FindNext   = RECORD Flags,AX : WORD; SDB : SDB_Rec; DIB : Dir_Rec; END;
      Ans_SeekEnd    = RECORD Flags,AX : WORD; SFT : SFT_Rec; END;
      Ans_ExtendOpen = RECORD Flags,AX,CX : WORD; SFT : SFT_Rec; END;

      { Struktur fr wirklich alle Register (im Gegensatz zu Registers) }
      RegSet = RECORD
        BP,ES,DS,DI,SI,DX,CX,BX,AX,SS,SP,CS,IP,Flags:WORD;
      END;

      { fr Longint- und Zeigermanipulation }
      os = RECORD
        o,s : WORD;
      END;

{ Laufwerks-ID }

CONST ID_Max    = 7;
      DriveName = 'RMT. :\'#0;
      ID_Drv    : ARRAY [0..ID_Max] OF CHAR = DriveName;

IMPLEMENTATION
END.
