(* ------------------------------------------------------ *)
(*                      RES1.PAS                          *)
(*       Demonstration der Verwendung von Ressourcen      *)
(*             (c) 1993 te-wi Verlag, Mnchen             *)
(* ------------------------------------------------------ *)
PROGRAM Res1;

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

USES Objects, Drivers, Views, Menus, App;

TYPE
  tAnApp = OBJECT (tApplication)
    CONSTRUCTOR Init;
    PROCEDURE   InitMenuBar;    VIRTUAL;
    PROCEDURE   InitStatusLine; VIRTUAL;
    DESTRUCTOR  Done;           VIRTUAL;
  END;

VAR
  ResFile : tResourceFile;

  CONSTRUCTOR tAnApp.Init;
  BEGIN
    RegisterMenus;
    RegisterObjects;
    RegisterViews;
    RegisterApp;
    inherited Init;
  END;

  PROCEDURE tAnApp.InitMenuBar;
  VAR
    R : tRect;
  BEGIN
    GetExtent(R);
    R.B.Y := R.A.Y + 1;
    MenuBar := New(PMenuBar, Init(R, NewMenu(
      NewSubMenu('~D~atei', hcNoContext, NewMenu(
        StdFileMenuItems(nil)),
      nil))));
  END;

  PROCEDURE tAnApp.InitStatusLine;
  VAR
    R : tRect;
  BEGIN
    GetExtent(R);
    R.A.Y := R.B.Y - 1;
    StatusLine := New(pStatusLine, Init(R,
      NewStatusDef(0, $FFFF,
        NewStatusKey('~F3~ ffnen', kbF3, cmOpen,
        NewStatusKey('~F2~ Speichern', kbF3, cmSave,
        NewStatusKey('~Alt+X~ Beenden', kbAltX, cmQuit,
      NIL))),
    NIL)));
  END;

  DESTRUCTOR tAnApp.Done;
  BEGIN
    ResFile.Init(New(pBufStream, Init('RES1.RES', stCreate, 1024)));
    ResFile.Put(MenuBar, 'APPMENU');
    ResFile.Put(StatusLine, 'STATLINE');
    ResFile.Done;
    inherited Done;
  END;

VAR
  AnApp : tAnApp;

BEGIN
  AnApp.Init;
  AnApp.Run;
  AnApp.Done;
END.
(* ------------------------------------------------------ *)
(*                 Ende von RES1.PAS                      *)

 
