(* ------------------------------------------------------ *)
(*                    IDE_DLG.PAS                         *)
(*             (c) 1993 te-wi Verlag, Mnchen             *)
(* ------------------------------------------------------ *)
UNIT IDE_Dlg;

{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}

INTERFACE

USES Objects, Drivers, Memory, Views, Menus, App,
     Dialogs, MsgBox, StdDlg;

  FUNCTION CreateDirDialog : pDialog;

  FUNCTION AsmOptDlg : pDialog;

(* -------- Assembler Options Data Transfer ------------- *)

TYPE
  AsmOptRec = RECORD
                SegOrder  : WORD;
                DebugInfo : WORD;
                CrossRef : WORD;
                Warnings : WORD;
                Floating  : WORD;
                Listing   : WORD;
                ListErr   : WORD;
                Code      : WORD;
                Special   : WORD;
              END;

  FUNCTION LinkOptDlg : pDialog;

(* -------- Linker Options Data Transfer ---------------- *)

TYPE
  LinkOptRec = RECORD
                 DebugInfo : WORD;
                 MemSwap   : WORD;
                 Libraries : WORD;
                 Target    : WORD;
               END;

IMPLEMENTATION

  FUNCTION CreateDirDialog : pDialog;
  VAR
    D : pDialog;
    C : pView;
    R : tRect;
  BEGIN
    R.Assign(0, 0, 50, 15);
    D := New(pDialog, Init(R, 'Edit Directory Configuration'));

    WITH D^ DO BEGIN
      Options := Options OR ofCentered;

      R.Assign(3, 3, 47, 4);
      C := New(pInputLine, Init(R, 79));
      Insert(C);
      R.Assign(2, 2, 15, 3);
      Insert(New(pLabel, Init(R, '~U~tilities', C)));

      R.Assign(3, 5, 47, 6);
      C := New(pInputLine, Init(R, 79));
      Insert(C);
      R.Assign(2, 4, 25, 5);
      Insert(New(pLabel, Init(R, '~L~ibraries (*.LIB)', C)));

      R.Assign(3, 7, 47, 8);
      C := New(pInputLine, Init(R, 79));
      Insert(C);
      R.Assign(2, 6, 25, 7);
      Insert(New(pLabel, Init(R, '~O~bjects (*.OBJ)', C)));

      R.Assign(3, 9, 47, 10);
      C := New(pInputLine, Init(R, 79));
      Insert(C);
      R.Assign(2, 8, 15, 9);
      Insert(New(pLabel, Init(R, '~I~ncludes', C)));

      R.Assign(15, 12, 25, 14);
      Insert(New(pButton, Init(R, 'O~k~', cmOk, bfDefault)));
      Inc(R.A.X, 12);  Inc(R.B.X, 12);
      Insert(New(pButton, Init(R, '~C~ancel', cmCancel, bfNormal)));
    END;
    CreateDirDialog := D;
  END;

  FUNCTION AsmOptDlg : pDialog;
  VAR
    D : pDialog;
    C : pView;
    R : tRect;
  BEGIN
    R.Assign(0, 0, 75, 22);
    D := New(pDialog, Init(R, 'Assembly Options'));

    WITH D^ DO BEGIN
      Options := Options OR ofCentered;

      R.Assign(3, 3, 30, 5);
      C := New(pRadioButtons, Init(R,
        NewSItem('Alphabetic      (/a)',
        NewSItem('Source Code     (/s)',
      NIL))));
      Insert(C);
      R.Assign(2, 2, 20, 3);
      Insert(New(pLabel, Init(R, 'Segment ~O~rdering', C)));

      R.Assign(3, 7, 30, 10);
      C := New(pRadioButtons, Init(R,
        NewSItem('Full            (/zi)',
        NewSItem('Line Numbers    (/zd)',
        NewSItem('None            (/zn)',
      NIL)))));
      Insert(C);
      R.Assign(2, 6, 22, 7);
      Insert(New(pLabel, Init(R, '~D~ebug Information', C)));

      R.Assign(3, 11, 30, 12);
      Insert(New(pCheckBoxes, Init(R,
        NewSItem('~C~ross Reference (/c)',
      NIL))));

      R.Assign(3, 14, 30, 17);
      C := New(pRadioButtons, Init(R,
        NewSItem('None  0         (/w0)',
        NewSItem('Level 1         (/w1)',
        NewSItem('Level 2         (/w2)',
      NIL)))));
      Insert(C);
      R.Assign(2, 13, 22, 14);
      Insert(New(pLabel, Init(R, '~W~arning Level', C)));

      R.Assign(33, 3, 72, 5);
      C := New(pRadioButtons, Init(R,
        NewSItem('Emulated                   (/e)',
        NewSItem('Real                       (/r)',
      NIL))));
      Insert(C);
      R.Assign(32, 2, 50, 3);
      Insert(New(pLabel, Init(R, '~F~loating Point', C)));

      R.Assign(33, 7, 72, 9);
      C := New(pRadioButtons, Init(R,
        NewSItem('Normal                     (/l)',
        NewSItem('Expanded                   (/la)',
      NIL))));
      Insert(C);
      R.Assign(32, 6, 50, 7);
      Insert(New(pLabel, Init(R, '~L~isting', C)));
      R.Assign(33, 9, 72, 12);
      Insert(New(pCheckBoxes, Init(R,
        NewSITem('No Symbol ~t~ables           (/n)',
        NewSItem('Source line ~w~ith error     (/z)',
        NewSItem('~I~nclude false conditionals (/x)',
      NIL))))));

      R.Assign(33, 14, 72, 18);
      C := New(pRadioButtons, Init(R,
        NewSItem('Standard                   (/os)',
        NewSItem('Standard with overlays     (/o)',
        NewSItem('Phar Lap                   (/op)',
        NewSItem('IBM                        (/oi)',
      NIL))))));
      Insert(C);
      R.Assign(32, 13, 52, 14);
      Insert(New(pLabel, Init(R, 'Code ~G~eneration', C)));

      R.Assign(33, 19, 72, 21);
      Insert(New(pCheckBoxes, Init(R,
        NewSItem('Check for CS o~v~errides     (/p)',
        NewSItem('Suppress OBJ ~r~ecords       (/q)',
      NIL)))));

      R.Assign(4, 19, 14, 21);
      Insert(New(pButton, Init(R, 'O~k~', cmOk, bfDefault)));
      Inc(R.A.X, 12);  Inc(R.B.X, 12);
      Insert(New(pButton, Init(R, '~C~ancel', cmCancel, bfNormal)));

    END;
    AsmOptDlg := D;
  END;

  FUNCTION LinkOptDlg : pDialog;
  VAR
    D : pDialog;
    C : pView;
    R : tRect;
  BEGIN
    R.Assign(0, 0, 75, 22);
    D := New(pDialog, Init(R, 'Linker Options'));

    WITH D^ DO BEGIN
      Options := Options OR ofCentered;

      R.Assign(3, 3, 33, 10);
      C := New(pCheckBoxes, Init(R,
        NewSItem('Map file with publics    (/m)',
        NewSItem('No map file              (/x)',
        NewSItem('Include line numbers     (/l)',
        NewSItem('Detailed map od segs     (/s)',
        NewSItem('Full debug information   (/v)',
        NewSItem('Initialize all segments  (/i)',
        NewSItem('Overlay switch           (/o)',
      NIL)))))))));
      Insert(C);
      R.Assign(2, 2, 30, 3);
      Insert(New(pLabel, Init(R, '~D~ebug Information', C)));

      R.Assign(3, 12, 33, 14);
      C := New(pRadioButtons, Init(R,
        NewSItem('Expanded memory   (/ye)',
        NewSItem('Extended memory   (/yx)',
      NIL))));
      Insert(C);
      R.Assign(2, 11, 22, 12);
      Insert(New(pLabel, Init(R, '~M~emory swapping', C)));

      R.Assign(33, 3, 72, 10);
      C := New(pCheckBoxes, Init(R,
        NewSItem('No default libraries        (/n)',
        NewSItem('Warn if duplicate symbols   (/d)',
        NewSItem('Case significant in symbols (/c)',
        NewSItem('Ignore extended dictionary  (/e)',
        NewSItem('Case sensitive exports      (/C)',
        NewSItem('Enable 32-bit processing    (/3)',
      NIL))))))));
      Insert(C);
      R.Assign(32, 2, 50, 3);
      Insert(New(pLabel, Init(R, '~L~ibraries', C)));

      R.Assign(33, 12, 72, 18);
      C := New(pRadioButtons, Init(R,
        NewSItem('COM for DOS                 (/Tdc)',
        NewSItem('EXE for DOS                 (/Tdx)',
        NewSItem('DLL for DOS                 (/Tdd)',
        NewSItem('COM for Windows             (/Twc)',
        NewSItem('EXE for Windows             (/Twx)',
        NewSItem('DLL for Windows             (/Twd)',
      NIL))))))));
      Insert(C);
      R.Assign(32, 11, 50, 12);
      Insert(New(pLabel, Init(R, '~O~utput', C)));

      R.Assign(4, 19, 14, 21);
      Insert(New(pButton, Init(R, 'O~k~', cmOk, bfDefault)));
      Inc(R.A.X, 12);  Inc(R.B.X, 12);
      Insert(New(pButton, Init(R, '~C~ancel', cmCancel, bfNormal)));

    END;
    LinkOptDlg := D;
  END;

END.
(* ------------------------------------------------------ *)
(*               Ende von IDE_DLG.PAS                     *)


