PROGRAM ReeAccess3;

USES WinTypes, WinProcs, WObjects, ReeFace;

{$R ReeXs3}

TYPE
  PMyWindow = ^TMyWindow;
  TMyWindow = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE Destroy; VIRTUAL;
    PROCEDURE WMTimer (VAR Msg: tMessage); VIRTUAL wm_First + wm_Timer;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
    PROCEDURE InitInstance; VIRTUAL;
  END;

CONSTRUCTOR TMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
END;

PROCEDURE TMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, 'ReeXs3');
END;

PROCEDURE TMyWindow.SetupWindow;
BEGIN
  tWindow.SetupWindow;
  ShowWindow (hWindow, sw_ShowMinNoActive);
  SetTimer (hWindow, 3, 10000, NIL);
END;

PROCEDURE TMyWindow.Destroy;
BEGIN
  KillTimer (hWindow, 3);
  tWindow.Destroy;
END;

PROCEDURE TMyWindow.WMTimer (VAR Msg: tMessage);
BEGIN
  IF (Msg.wParam = 3) THEN
    ReeFace.SetValue (10);
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (PMyWindow, Init(NIL, 'Set Value to 10'));
END;

PROCEDURE tMyApplication.InitInstance;
BEGIN
  InitMainWindow;
  MainWindow := MakeWindow(MainWindow);
  IF (MainWindow <> NIL)
    THEN MainWindow^.Show (sw_ShowMinNoActive)
    ELSE Status := em_InvalidMainWindow;
END;

VAR
  GenericApp: tMyApplication;

BEGIN
  GenericApp.Init ('ReeAccess 3');
  GenericApp.Run;
  GenericApp.Done;
END.
