PROGRAM Owner;

{$R Owner}

USES WinTypes, WinProcs, WinDos, Strings, BWCC, OWindows, ODialogs;

(* Beispielprogramm fr Borland Windows Custom Controls und Menspielereien *)
(* mit Turbo Pascal fr Windows.                                            *)

CONST
  cm_About    = 100;
  cm_WinMsgBox= 101;
  cm_BorMsgBox= 102;
  cm_Haegar   = 103;
  cm_Hilfe    = 901;

  id_Munch     = 200;
  id_Boticelli = 201;
  id_EGAVGA    = 202;

  id_Punkt1    = 401;
  id_Punkt2    = 402;
  id_Punkt3    = 403;
  cm_Gray      = 404;
  cm_Check     = 405;
  cm_Disable   = 406;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    Punkt1Grayed: BOOLEAN;
    Punkt2Checked: BOOLEAN;
    Punkt3Disabled: BOOLEAN;

    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;

    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + cm_About;
    PROCEDURE WinMsgBox (VAR Msg: tMessage); VIRTUAL cm_First + cm_WinMsgBox;
    PROCEDURE BorMsgBox (VAR Msg: tMessage); VIRTUAL cm_First + cm_BorMsgBox;
    PROCEDURE Punkt3 (VAR Msg: tMessage); VIRTUAL cm_First + id_Punkt3;
    PROCEDURE ManipPunkt1 (VAR Msg: tMessage); VIRTUAL cm_First + cm_Gray;
    PROCEDURE ManipPunkt2 (VAR Msg: tMessage); VIRTUAL cm_First + cm_Check;
    PROCEDURE ManipPunkt3 (VAR Msg: tMessage); VIRTUAL cm_First + cm_Disable;

    PROCEDURE wmSysCommand (VAR Msg: tMessage); VIRTUAL wm_First + wm_SysCommand;
  END;

  pMyDialog = ^tMyDialog;
  tMyDialog = OBJECT (tDialog)
    PROCEDURE Munch (VAR Msg: tMessage); VIRTUAL id_First + id_Munch;
    PROCEDURE Boticelli (VAR Msg: tMessage); VIRTUAL id_First + id_Boticelli;
    PROCEDURE EGAVGA (VAR Msg: tMessage); VIRTUAL id_First + id_EGAVGA;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  NewBitmap: hBitmap;
  GenericApp: tMyApplication;

(************************************ TMyWindow *******************************)

(* Methoden zum Aufbau des Applikationsfensters *)

CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.Menu := LoadMenu(hInstance, 'OwnerMenu');
  Punkt1Grayed := FALSE;
  Punkt2Checked := FALSE;
  Punkt3Disabled := FALSE;
END;

PROCEDURE tMyWindow.SetupWindow;
VAR
  MyMenu: hMenu;
  SystemVerz, SuchPfad: ARRAY [0..255] OF CHAR;
BEGIN
  tWindow.SetupWindow;
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_Separator, 0, NIL);
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_String, cm_About, 'ber dieses Programm...');
  NewBitmap := LoadBitmap (hInstance, 'Haegar4');
  MyMenu := GetMenu (hWindow);
  ModifyMenu (MyMenu, cm_Haegar, mf_ByCommand OR mf_Bitmap, cm_Haegar, pChar(NewBitmap));

  (* Prfen, ob die BWCC.DLL auch wirklich im Zugriffspfad vorhanden ist *)
  GetSystemDirectory (SystemVerz, 256);
  FileSearch (SuchPfad, 'BWCC.DLL', SystemVerz);
  IF (StrLen(SuchPfad) = 0) THEN BEGIN
    MessageBox (hWindow, 'BWCC.DLL konnte nicht gefunden werden','Programm wird abgebrochen!', mb_OK OR mb_IconInformation);
    Halt;
  END ELSE MessageBox (hWindow, SuchPfad, 'BWCC gefunden', mb_OK OR mb_IconInformation);
END;

PROCEDURE tMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, 'MYICON');
END;

(* Antwortmethode fr Menoption im Men "Dialogfenster und mehr..." *)

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: tMyDialog;
BEGIN
  Dialog.Init(@Self, 'OwnerDraw');
  Dialog.Execute;
  Dialog.Done;
END;

(* Antwortmethoden fr Menoptionen im Men "Mitteilungsfenster" *)

PROCEDURE tMyWindow.WinMsgBox (VAR Msg: tMessage);
BEGIN
  MessageBeep(0);
  MessageBox (hWindow,
    'Die MessageBox im Windows Stil',
    'MessageBox',
    mb_YesNoCancel);
END;

PROCEDURE tMyWindow.BorMsgBox (VAR Msg: tMessage);
BEGIN
  BWCCMessageBox (hWindow,
    'Die MessageBox im Borland-Stil mit der Unit BWCC.PAS',
    'MessageBox',
    mb_YesNoCancel);
END;

(* Antwortmethoden fr Menoptionen im Men "Menmanipulationen" *)

PROCEDURE tMyWindow.Punkt3 (VAR Msg: tMessage);
BEGIN
  MessageBeep(0);
END;

PROCEDURE tMyWindow.wmSysCommand (VAR Msg: tMessage);
BEGIN
  CASE Msg.wParam OF
    cm_About: About(Msg);
    ELSE DefWndProc(Msg);
  END;
END;

PROCEDURE tMyWindow.ManipPunkt1 (VAR Msg: tMessage);
BEGIN
  IF Punkt1Grayed
    THEN BEGIN
      EnableMenuItem(GetMenu(hWindow), id_Punkt1, mf_ByCommand OR mf_Enabled);
      ModifyMenu(GetMenu(hWindow), cm_Gray, mf_ByCommand OR mf_String, cm_Gray, 'Punkt 1 grau darstellen');
    END
    ELSE BEGIN
      EnableMenuItem(GetMenu(hWindow), id_Punkt1, mf_ByCommand OR mf_Enabled OR mf_Grayed);
      ModifyMenu(GetMenu(hWindow), cm_Gray, mf_ByCommand OR mf_String, cm_Gray, 'Punkt 1 normal darstellen');
    END;
  Punkt1Grayed := NOT Punkt1Grayed;
END;

PROCEDURE tMyWindow.ManipPunkt2 (VAR Msg: tMessage);
BEGIN
  IF Punkt2Checked
    THEN BEGIN
      CheckMenuItem(GetMenu(hWindow), id_Punkt2, mf_Unchecked);
      ModifyMenu (GetMenu(hWindow), cm_Check, mf_ByCommand OR mf_String, cm_Check, 'Punkt 2 mit Hkchen');
    END
    ELSE BEGIN
      CheckMenuItem(GetMenu(hWindow), id_Punkt2, mf_Checked);
      ModifyMenu (GetMenu(hWindow), cm_Check, mf_ByCommand OR mf_String, cm_Check, 'Punkt 2 ohne Hkchen');
    END;
  Punkt2Checked := NOT Punkt2Checked;
END;

PROCEDURE tMyWindow.ManipPunkt3 (VAR Msg: tMessage);
BEGIN
  IF Punkt3Disabled
    THEN BEGIN
      EnableMenuItem(GetMenu(hWindow), id_Punkt3, mf_ByCommand OR mf_Enabled);
      ModifyMenu(GetMenu(hWindow), cm_Disable, mf_ByCommand OR mf_String, cm_Disable, 'Punkt 3 abschalten');
    END
    ELSE BEGIN
      EnableMenuItem(GetMenu(hWindow), id_Punkt3, mf_ByCommand OR mf_Disabled);
      ModifyMenu(GetMenu(hWindow), cm_Disable, mf_ByCommand OR mf_String, cm_Disable, 'Punkt 3 anschalten');
    END;
  Punkt3Disabled := NOT Punkt3Disabled;
END;

(************************************ TMyDialog *******************************)
(* Diese Methoden werden im Dialogfenster bentigt, das durch die Option      *)
(* "Borland Dialogfenster" im Untermen "Dialogfenster und mehr..."           *)
(* aufgerufen wird.                                                           *)

PROCEDURE tMyDialog.Munch (VAR Msg: tMessage);
BEGIN
  Cancel(Msg);
END;

PROCEDURE tMyDialog.Boticelli (VAR Msg: tMessage);
BEGIN
  MessageBeep(0);
END;

PROCEDURE tMyDialog.EGAVGA (VAR Msg: tMessage);
BEGIN
  MessageBeep(0);
END;

(************************************ TMyApplication **************************)

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'Beispielprogramm Borland-Style Custom Controls'));
END;

(************************************ Hauptprogramm ***************************)

BEGIN
  GenericApp.Init ('GenericApp');
  GenericApp.Run;
  GenericApp.Done;
END.
