PROGRAM RevCurs;

{$R RevCurs}

USES WinDos, WObjects, WinTypes, WinProcs, Strings;

CONST
  { Command ID }
  idm_About = 100;
  idm_ChangeCursor = 101;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    CursorID: INTEGER;
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + idm_About;
    PROCEDURE ChangeCursor (VAR Msg: tMessage); VIRTUAL cm_First + idm_ChangeCursor;
    PROCEDURE wmSysCommand (VAR Msg: tMessage); VIRTUAL wm_First + wm_SysCommand;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  GenericApp: tMyApplication;

CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  CursorID := 4;
  Attr.Menu := LoadMenu(hInstance, 'RevCursors');
END;

PROCEDURE tMyWindow.SetupWindow;
BEGIN
  tWindow.SetupWindow;
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_Separator, 0, NIL);
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_String, idm_ChangeCursor, 'Change Cursor');
END;

PROCEDURE tMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hCursor := LoadCursor (hInstance, 'TREK');
  aWndClass.hIcon := LoadIcon (hInstance, 'ICON_2');
END;

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: pDialog;
BEGIN
  Dialog := New(pDialog, Init(@Self, 'AboutBox'));
  Application^.ExecDialog (Dialog);
END;

PROCEDURE tMyWindow.ChangeCursor (VAR Msg: tMessage);
VAR
  NewCursor: hCursor;
  Rect: tRect;
BEGIN
  CASE (CursorID MOD 8) OF
     0: NewCursor := LoadCursor (hInstance, 'TREK');
     1: NewCursor := LoadCursor (0, idc_Cross);
     2: NewCursor := LoadCursor (0, idc_IBeam);
     3: NewCursor := LoadCursor (0, idc_Icon);
     4: NewCursor := LoadCursor (0, idc_Size);
     5: NewCursor := LoadCursor (0, idc_SizeNESW);
     6: NewCursor := LoadCursor (0, idc_UPArrow);
     7: NewCursor := LoadCursor (0, idc_Arrow);
  END;
  Inc(CursorID);
  SetClassWord (hWindow, gcw_HCursor, NewCursor);
END;

PROCEDURE tMyWindow.wmSysCommand (VAR Msg: tMessage);
BEGIN
  CASE Msg.wParam OF
    idm_ChangeCursor: ChangeCursor (Msg);
    ELSE DefWndProc (Msg);
  END;
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'Changing Cursors'));
END;

BEGIN
  GenericApp.Init ('ChangeCursors');
  GenericApp.Run;
  GenericApp.Done;
END.
